<script lang="ts">
import Vue from 'vue';
import { UseLiteVimeo, UseLocalizedVideoSubtitles } from '~/mixins';

export default Vue.extend({
  name: 'EnterpriseCTA',
  mixins: [UseLiteVimeo, UseLocalizedVideoSubtitles],
  props: {
    data: {
      type: Object,
      required: true,
      default: null,
    },
  },
});
</script>

<template>
  <section class="enterprise-cta">
    <SlpRow>
      <SlpColumn :cols="6" class="slp-flex slp-align-items-center">
        <div class="cta__title-column">
          <SlpTypography tag="h1" variant="heading1">{{
            data.title
          }}</SlpTypography>
          <SlpTypography
            tag="h3"
            variant="heading3"
            class="slp-my-16 slp-mb-0"
            >{{ data.subtitle }}</SlpTypography
          >
          <div class="slp-mb-16">
            <SlpButton
              class="slp-mr-8"
              variant="primary"
              :href="data.primaryButton.link"
              :data-ga-name="data.primaryButton.data_ga_name"
              :data-ga-location="data.primaryButton.data_ga_location"
              >{{ data.primaryButton.text }}</SlpButton
            >
            <SlpButton
              variant="secondary"
              :href="data.secondary_button.link"
              :data-ga-name="data.secondary_button.data_ga_name"
              :data-ga-location="data.secondary_button.data_ga_location"
              >{{ data.secondary_button.text }}</SlpButton
            >
          </div>
          <SlpTypography
            v-if="data.tag_line"
            tag="p"
            variant="body1"
            class="slp-mb-24"
            >{{ data.tag_line }}</SlpTypography
          >
          <div
            v-if="data.showcased_enterprises"
            class="cta__companies slp-flex"
          >
            <span
              v-for="enterprise in data.showcased_enterprises"
              :key="enterprise.alt"
              class="slp-mr-4 slp-mt-8"
            >
              <a :href="enterprise.url" target="_blank">
                <nuxt-img
                  class="cta__company-icon"
                  :src="enterprise.image_url"
                  :alt="enterprise.alt"
                  loading="lazy"
                  format="webp"
                  quality="99"
                />
              </a>
            </span>
          </div>
        </div>
      </SlpColumn>
      <SlpColumn
        :cols="6"
        class="cta__media-column slp-flex slp-align-items-center"
      >
        <div v-if="data.video" class="cta__video">
          <lite-vimeo
            :videoid="getVideoVimeoId(createVideoSource(data.video.video_url))"
            autoplay
          ></lite-vimeo>
        </div>
        <div v-else-if="data.image">
          <nuxt-img
            class="cta__image"
            :src="data.image.image_url"
            :alt="data.image.alt"
            loading="lazy"
            format="webp"
            quality="99"
          />
        </div>
      </SlpColumn>
    </SlpRow>
  </section>
</template>

<style lang="scss" scoped>
.enterprise-cta {
  margin-bottom: $spacing-48;
  margin-top: $spacing-96;

  @media (max-width: $breakpoint-md) {
    margin-top: $spacing-24;
    text-align: center;

    h1 {
      font-size: $text-heading-1-mobile;
      line-height: $line-height-heading-1-mobile;
    }

    h3 {
      font-size: $text-heading-2-mobile;
      line-height: $line-height-heading-2-mobile;
      margin-bottom: 0;
    }

    .slp-btn {
      width: 100%;
      margin-top: $spacing-8;
    }

    .cta__video {
      margin-left: 0;
    }

    .cta__companies {
      justify-content: space-around;
    }

    .cta__title-column {
      margin-right: 0;
      margin-bottom: $spacing-24;
    }
  }
}

.cta__companies {
  flex-wrap: wrap;
  justify-content: space-around;
}

.cta__title-column {
  margin-right: $spacing-32;
}

.cta__media-column {
  margin: 0 auto;

  @media (max-width: $breakpoint-md) {
    width: unset;
  }
}

.cta__company-icon {
  height: 18px;
}

.cta__image {
  max-height: 362px;
  max-width: 100%;
}

.cta__video {
  width: 560px;
  height: 315px;
  margin-left: $spacing-32;
  lite-vimeo {
    height: 100%;
    width: 100%;
  }
}
</style>
